<!DOCTYPE html>
<meta HTTP-EQUIV="PRAGMA" CONTENT="NO-CACHE">
<meta name="viewport" content="initial-scale=1.0, user-scalable=no" />
	
<script src="jquery-2.0.3.min.js" ></script>

<script>
	$(document).ready(function(){
		$("#recordBtn").prop("disabled",true);
		$("#playBtn").prop("disabled",true);
		$(document).on("click","#recordBtn", onRecordBtnClicked);
		$(document).on("click","#playBtn", onPlayBtnClicked);
	});
	
	function onRecordBtnClicked()
	{
		var btnTxt = $("#recordBtn").prop("value");
		if (btnTxt == "Record")
			startRecording(); 
		else
			stopRecording();
	}
	
	function onPlayBtnClicked()
	{
		var btnTxt = $("#playBtn").prop("value");
		if (btnTxt == "Play")
			playAudio(); 
		else
			stopAudio();
	}
	
	function displayMessage (msg, append)
	{
		var divElm = document.getElementById("msgDiv");
		if (append != undefined && !append)
			divElm.innerHTML = "";
		divElm.innerHTML += msg;
	}
	
</script>

<h1>CFMobile Audio Demo</h1>
Click on the Record buton and speak. When done, click the Stop button.<p>
You can playback recorded audio by clicking the Play button<p>

<input type="button" value="Record" id="recordBtn" style="margin-right:20px">
<input type="button" value="Play" id="playBtn">

<h2>Messages</h2>
<div id="msgDiv"></div>
	
<cfclientsettings enabledeviceapi="true" >
<cfclient>
	<cfscript>
		$("##recordBtn").prop("disabled",false);
		$("##playBtn").prop("disabled",false);
		
		
		RECORDING_STARTED = 10;
		MEDIA_STOPPED = 4;
		MEDIA_PAUSED = 3;
		MEDIA_RUNNING = 2;
		PLAYBACK_STARTED = 11;
		MEDIA_NONE = 0;
		
		mediaFile = null;
		mediaObj = null;
		audioStatus = MEDIA_NONE;
		
		function startRecording()
		{
			try
			{
				//Get current file system
				var currFileSys = cfclient.file.getFileSystem();
				displayMessage("Current file sys path - " + currFileSys.root.fullPath + "<br><hr>", false);
				
				//Set temporary file system
				cfclient.file.setFileSystem("temporary");
				var tempFileSys = cfclient.file.getFileSystem();
				displayMessage("Temporary file sys path - " + tempFileSys.root.fullPath + "<br><hr>");
				
				//Set persistent file system
				cfclient.file.setFileSystem("persistent");
				var persistFileSys = cfclient.file.getFileSystem();
				displayMessage("Persistent file sys path - " + persistFileSys.root.fullPath + "<br><hr>");

				//restore file system				
				cfclient.file.setFileSystem(currFileSys.name);
				
				var mediaFileName = "tempMedia.wav";
				
				mediaObj = cfclient.audio.createMedia(mediaFileName, function(statusArg){
					mediaStatusChanged(statusArg);
				});
				
				//check if the file is in temporary file system - true for iOS
				var filePath = tempFileSys.root.fullPath + "/" + mediaFileName;
				if (filePathExists(filePath))
				{
					displayMessage("Temporary file created - " +  filePath + "<br><hr>");
					//move it to persistent file system
					copyFileFromTempToPersistentFileSystem(filePath);
				}
				else {
					//check if file is in persistent file system - true for Android
					filePath = persistFileSys.root.fullPath + "/" + mediaFileName;	
					if (filePathExists(filePath))
						displayMessage("Persistent file created - " +  filePath + "<br><hr>");									
				}
				
				//start recording
				cfclient.audio.record(mediaObj);
				
				audioStatus = RECORDING_STARTED;
				
				//update buttons
				mediaStatusChanged(RECORDING_STARTED);
			}
			catch (any e)
			{
				displayMessage("Error recording - " + JSON.stringify(e) + "<br><hr>");
			}
		}
		
		function stopRecording()
		{
			if (isDefined("mediaObj"))
			{
				cfclient.audio.stopRecording(mediaObj);
			}
		}
		
		function filePathExists (path)
		{
			try
			{
				cfclient.file.get(path);
				return true;
			}
			catch (any e)
			{
				return false;				
			}
		}
		
		function mediaStatusChanged (statusArg)
		{
			switch (statusArg)
			{
				case 4: //MEDIA_STOPPED:
					$("##recordBtn").prop("disabled",false);
					$("##recordBtn").prop("value", "Record");
					$("##playBtn").prop("disabled",false);
					$("##playBtn").prop("value", "Play");
					audioStatus = MEDIA_NONE;
					break;
				//TODO: Handle pause media status
				case 11: //PLAYBACK_STARTED:
					$("##recordBtn").prop("disabled",true);
					$("##playBtn").prop("disabled",false);
					$("##playBtn").prop("value", "Stop");
					audioStatus = PLAYBACK_STARTED;
					break;
				case 10://RECORDING_STARTED:
					$("##recordBtn").prop("disabled",false);
					$("##recordBtn").prop("value", "Stop");
					$("##playBtn").prop("disabled",true);
					audioStatus = RECORDING_STARTED;
					break;
			}
		}
		
		function playAudio ()
		{
			if (isDefined("mediaObj"))
			{
				//workaround for Android. Create media object again
				mediaObj = cfclient.audio.createMedia(mediaObj.src, function(statusArg){
					mediaStatusChanged(statusArg);
				});
				
				cfclient.audio.play(mediaObj);
				mediaStatusChanged(PLAYBACK_STARTED);
			}
			else 
				alert("No recording avilable to play");			
		}
		
		function stopAudio()
		{
			cfclient.audio.stop(mediaObj);
		}
		
		function copyFileFromTempToPersistentFileSystem (tempFilePath)
		{
			//save existing file system
			var oldFileSystem = cfclient.file.getFileSystem();
			
			//Get file object from the path
			var tmpFile = cfclient.file.get(tempFilePath);
			
			//set persistent file system
			var persistentfileSystem = cfclient.file.setFileSystem("persistent");
			
			var newFilePath = persistentfileSystem.root.fullPath + "/" + tmpFile.name;
				
			//If file with the same name exists in the persistent file system, then try save
			//it with different name
			var count = 1;
			while (count < 10)
			{
				try
				{
					cfclient.file.get(newFilePath);
						
					//file already exists. Try different file name
					count++;
					newFilePath = persistentfileSystem.root.fullPath + "/" + replace(tmpFile.name,".","_") + "_" + count + ".wav";
				} 
				catch (any e) {
					//Assume file does not exists. Go ahead and copy from temp location to persistent location.	
					console.log("Exception : " + e.message);
					break;
				}
			}
			
			//Copy file
			cfclient.file.copy(tempFilePath,newFilePath);
			displayMessage("Audio file copied to " + newFilePath + "<br><hr>");
				
			//Restore old file system
			cfclient.file.setFileSystem(oldFileSystem.name);
			
			//return new file path
			return newFilePath;
		}
		
	</cfscript>
</cfclient>