<!DOCTYPE html>
<meta HTTP-EQUIV="PRAGMA" CONTENT="NO-CACHE">
<meta name="viewport" content="initial-scale=1.0, user-scalable=no" />
	
<script src="jquery-2.0.3.min.js" ></script>

<script>
	$(document).ready(function(){
		$("#recordBtn").prop("disabled",true);
		$("#playBtn").prop("disabled",true);
		$(document).on("click","#recordBtn", onRecordBtnClicked);
		$(document).on("click","#playBtn", onPlayBtnClicked);
	});
	
	function onRecordBtnClicked()
	{
		var btnTxt = $("#recordBtn").prop("value");
		if (btnTxt == "Record")
			startRecording(); 
		else
			stopRecording();
	}
	
	function onPlayBtnClicked()
	{
		var btnTxt = $("#playBtn").prop("value");
		if (btnTxt == "Play")
			playAudio(); 
		else
			stopAudio();
	}
	
</script>

<h1>CFMobile Audio Demo</h1>
Click on the Record buton and speak. When done, click the Stop button.<p>
You can playback recorded audio by clicking the Play button<p>

<input type="button" value="Record" id="recordBtn" style="margin-right:20px">
<input type="button" value="Play" id="playBtn">
	
<cfclientsettings enabledeviceapi="true" >
<cfclient>
	<cfscript>
		$("##recordBtn").prop("disabled",false);
		$("##playBtn").prop("disabled",false);
		
		
		RECORDING_STARTED = 10;
		MEDIA_STOPPED = 4;
		MEDIA_PAUSED = 3;
		MEDIA_RUNNING = 2;
		PLAYBACK_STARTED = 11;
		MEDIA_NONE = 0;
		
		mediaFile = null;
		mediaObj = null;
		audioStatus = MEDIA_NONE;
		
		function startRecording()
		{
			try
			{
				var mediaFileName = "tempMedia.wav";
				
				mediaObj = cfclient.audio.createMedia(mediaFileName, function(statusArg){
					mediaStatusChanged(statusArg);
				});
				
				//For iOS, the media file would be created in the temporary file system
				//For Android, it will be created in the persistent file system
				
				//start recording
				cfclient.audio.record(mediaObj);
				audioStatus = RECORDING_STARTED;
				
				//update buttons
				mediaStatusChanged(RECORDING_STARTED);
			}
			catch (any e)
			{
				alert("Error recording - " + JSON.stringify(e));
			}
		}
		
		function stopRecording()
		{
			if (isDefined("mediaObj"))
			{
				cfclient.audio.stopRecording(mediaObj);
			}
		}
		
		function mediaStatusChanged (statusArg)
		{
			switch (statusArg)
			{
				case 4: //MEDIA_STOPPED:
					$("##recordBtn").prop("disabled",false);
					$("##recordBtn").prop("value", "Record");
					$("##playBtn").prop("disabled",false);
					$("##playBtn").prop("value", "Play");
					audioStatus = MEDIA_NONE;
					break;
				//TODO: Handle pause media status
				case 11: //PLAYBACK_STARTED:
					$("##recordBtn").prop("disabled",true);
					$("##playBtn").prop("disabled",false);
					$("##playBtn").prop("value", "Stop");
					audioStatus = PLAYBACK_STARTED;
					break;
				case 10://RECORDING_STARTED:
					$("##recordBtn").prop("disabled",false);
					$("##recordBtn").prop("value", "Stop");
					$("##playBtn").prop("disabled",true);
					audioStatus = RECORDING_STARTED;
					break;
			}
		}
		
		function playAudio ()
		{
			if (isDefined("mediaObj"))
			{
				//workaround for Android crash issue. Create media object again
				mediaObj = cfclient.audio.createMedia(mediaObj.src, function(statusArg){
					mediaStatusChanged(statusArg);
				});
				
				cfclient.audio.play(mediaObj);
				mediaStatusChanged(PLAYBACK_STARTED);
			}
			else 
				alert("No recording avilable to play");			
		}
		
		function stopAudio()
		{
			cfclient.audio.stop(mediaObj);
		}
	</cfscript>
</cfclient>